
// the number of reserved registers + machine registers.
#define REG_COUNT    133

// the number of save_on_entry + always_saved registers.
#define MAX_SAVED_ON_ENTRY_REG_COUNT    0
#define     SAVED_ON_ENTRY_REG_COUNT    0
#define   C_SAVED_ON_ENTRY_REG_COUNT    0

// Enumerate machine register numbers starting after reserved regs.
// in the order of occurrence in the register block.
enum MachRegisterNumbers {
  R_L0_num,		// 0
  R_L0H_num,		// 1
  R_L1_num,		// 2
  R_L1H_num,		// 3
  R_L2_num,		// 4
  R_L2H_num,		// 5
  R_L3_num,		// 6
  R_L3H_num,		// 7
  R_L4_num,		// 8
  R_L4H_num,		// 9
  R_L5_num,		// 10
  R_L5H_num,		// 11
  R_L6_num,		// 12
  R_L6H_num,		// 13
  R_L7_num,		// 14
  R_L7H_num,		// 15
  R_G0_num,		// 16
  R_G0H_num,		// 17
  R_G1_num,		// 18
  R_G1H_num,		// 19
  R_G2_num,		// 20
  R_G2H_num,		// 21
  R_G3_num,		// 22
  R_G3H_num,		// 23
  R_G4_num,		// 24
  R_G4H_num,		// 25
  R_G5_num,		// 26
  R_G5H_num,		// 27
  R_G6_num,		// 28
  R_G6H_num,		// 29
  R_G7_num,		// 30
  R_G7H_num,		// 31
  R_O7_num,		// 32
  R_O7H_num,		// 33
  R_SP_num,		// 34
  R_SPH_num,		// 35
  R_O0_num,		// 36
  R_O0H_num,		// 37
  R_O1_num,		// 38
  R_O1H_num,		// 39
  R_O2_num,		// 40
  R_O2H_num,		// 41
  R_O3_num,		// 42
  R_O3H_num,		// 43
  R_O4_num,		// 44
  R_O4H_num,		// 45
  R_O5_num,		// 46
  R_O5H_num,		// 47
  R_I0_num,		// 48
  R_I0H_num,		// 49
  R_I1_num,		// 50
  R_I1H_num,		// 51
  R_I2_num,		// 52
  R_I2H_num,		// 53
  R_I3_num,		// 54
  R_I3H_num,		// 55
  R_I4_num,		// 56
  R_I4H_num,		// 57
  R_I5_num,		// 58
  R_I5H_num,		// 59
  R_FP_num,		// 60
  R_FPH_num,		// 61
  R_I7_num,		// 62
  R_I7H_num,		// 63
  R_F8_num,		// 64
  R_F9_num,		// 65
  R_F10_num,		// 66
  R_F11_num,		// 67
  R_F12_num,		// 68
  R_F13_num,		// 69
  R_F14_num,		// 70
  R_F15_num,		// 71
  R_F16_num,		// 72
  R_F17_num,		// 73
  R_F18_num,		// 74
  R_F19_num,		// 75
  R_F20_num,		// 76
  R_F21_num,		// 77
  R_F22_num,		// 78
  R_F23_num,		// 79
  R_F24_num,		// 80
  R_F25_num,		// 81
  R_F26_num,		// 82
  R_F27_num,		// 83
  R_F28_num,		// 84
  R_F29_num,		// 85
  R_F30_num,		// 86
  R_F31_num,		// 87
  R_F0_num,		// 88
  R_F1_num,		// 89
  R_F2_num,		// 90
  R_F3_num,		// 91
  R_F4_num,		// 92
  R_F5_num,		// 93
  R_F6_num,		// 94
  R_F7_num,		// 95
  R_D32_num,		// 96
  R_D32x_num,		// 97
  R_D34_num,		// 98
  R_D34x_num,		// 99
  R_D36_num,		// 100
  R_D36x_num,		// 101
  R_D38_num,		// 102
  R_D38x_num,		// 103
  R_D40_num,		// 104
  R_D40x_num,		// 105
  R_D42_num,		// 106
  R_D42x_num,		// 107
  R_D44_num,		// 108
  R_D44x_num,		// 109
  R_D46_num,		// 110
  R_D46x_num,		// 111
  R_D48_num,		// 112
  R_D48x_num,		// 113
  R_D50_num,		// 114
  R_D50x_num,		// 115
  R_D52_num,		// 116
  R_D52x_num,		// 117
  R_D54_num,		// 118
  R_D54x_num,		// 119
  R_D56_num,		// 120
  R_D56x_num,		// 121
  R_D58_num,		// 122
  R_D58x_num,		// 123
  R_D60_num,		// 124
  R_D60x_num,		// 125
  R_D62_num,		// 126
  R_D62x_num,		// 127
  CCR_num,		// 128
  FCC0_num,		// 129
  FCC1_num,		// 130
  FCC2_num,		// 131
  FCC3_num,		// 132
  _last_Mach_Reg	// 133
};

// Size of register-mask in ints
#define RM_SIZE 8
// Unroll factor for loops over the data in a RegMask
#define FORALL_BODY BODY(0) BODY(1) BODY(2) BODY(3) BODY(4) BODY(5) BODY(6) BODY(7) 

class RegMask;
